package prog.labs.chat.ly;

import android.app.NotificationManager;
import android.app.PendingIntent;
import android.app.ProgressDialog;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.IntentSender;
import android.media.RingtoneManager;
import android.net.Uri;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.support.v4.app.NotificationCompat;
import android.util.Log;
import android.view.KeyEvent;
import android.widget.Toast;

import com.google.android.gms.common.ConnectionResult;
import com.google.android.gms.common.GooglePlayServicesClient;
import com.google.android.gms.plus.PlusClient;
import com.slidingmenu.lib.SlidingMenu;

import prog.labs.chat.ly.db.UserDAO;
import prog.labs.chat.ly.models.ChatFragment;

public class ChatIndex extends BaseActivity {

    private static final int REQUEST_CODE_RESOLVE_ERR = 9000;

    private ProgressDialog mConnectionProgressDialog;
    private PlusClient mPlusClient;
    private ConnectionResult mConnectionResult;

    private Fragment mContent;
	private MessageReceiver receiver;
	private UserDAO us;
	private String userguardado;
	private boolean ble = false;
	private boolean estado;

	public ChatIndex() {
		super(R.string.app_name);
		// TODO Auto-generated constructor stub
	}

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		
		estado = true;
		
		if (savedInstanceState != null)
			mContent = getSupportFragmentManager().getFragment(savedInstanceState, "mContent");
		if (mContent == null)
			mContent = new IndexFragment();
		
		IntentFilter filter = new IntentFilter(MessageReceiver.procesarrepuesta);
        filter.addCategory(Intent.CATEGORY_DEFAULT);
        receiver = new MessageReceiver();
        registerReceiver(receiver, filter);

		//La parte frontal
		setContentView(R.layout.activity_chat_index);
		getSupportFragmentManager()
		.beginTransaction()
		.replace(R.id.content_frame, mContent)
		.commit();
		
		ChatU ble = new ChatU();
		//El menu de usuarios
		setBehindContentView(R.layout.menu_frame);
		getSupportFragmentManager()
		.beginTransaction()
		.replace(R.id.menu_frame, ble)
		.commit();
		
		getSlidingMenu().setTouchModeAbove(SlidingMenu.TOUCHMODE_FULLSCREEN);

	} 	

	@Override
	protected void onPause() {
		// TODO Auto-generated method stub
		super.onPause();
		estado = false;
	}

	@Override
	protected void onResume() {
		// TODO Auto-generated method stub
		super.onResume();
		estado = true;
		if (ble) {
			ble = false;
			Fragment nuevofragmentin = new ChatFragment(userguardado);
			switchContent(nuevofragmentin);
		}
	}
	
	@Override
	public void onSaveInstanceState(Bundle outState) {
		super.onSaveInstanceState(outState);
		getSupportFragmentManager().putFragment(outState, "mContent", mContent);
	}
	
	public void switchContent(Fragment fragment) {
		mContent = fragment;
		getSupportFragmentManager()
		.beginTransaction()
		.replace(R.id.content_frame, fragment)
		.commit();
		getSlidingMenu().showContent();
	}

    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if (keyCode == KeyEvent.KEYCODE_BACK) {
            return false;
        }
        else{
            return super.onKeyDown(keyCode, event);
        }
    }


    public class MessageReceiver extends BroadcastReceiver{
		
		public static final String procesarrepuesta = "prog.labs.chat.ly.MENSAJERECIBIDO";

		@Override
		public void onReceive(Context arg0, Intent arg1) {
			// TODO Auto-generated method stub
			String responseString = arg1.getStringExtra("Userid");
			String nombre = arg1.getStringExtra("Nombreuser");
			String mensaje = arg1.getStringExtra("Mensajes");
			
			Fragment fragmentonuevo = new ChatFragment(responseString);
			int icon = R.drawable.ic_launcher;
			
			if(estado){
				switchContent(fragmentonuevo);	
				ble = false;
			}else{
				ble = true;
				userguardado = responseString;
				//Notificar al usuario cuando no esta la aplicacion en estado activo
		        NotificationManager notificationManager = (NotificationManager) arg0.getSystemService(Context.NOTIFICATION_SERVICE);
			      Uri soundUri = RingtoneManager.getDefaultUri(RingtoneManager.TYPE_NOTIFICATION);
			      NotificationCompat.Builder mBuilder = new NotificationCompat.Builder(getApplicationContext())
			              .setSmallIcon(icon)
			              .setContentTitle(nombre)
			              .setContentText(mensaje)
			              .setSound(soundUri).setAutoCancel(true); 

				      Intent notificationIntent = new Intent(arg0, ChatIndex.class);
				        notificationIntent.setFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP |
		                Intent.FLAG_ACTIVITY_SINGLE_TOP);
				        PendingIntent intent =  PendingIntent.getActivity(arg0, 0, notificationIntent, 0);
				        mBuilder.setContentIntent(intent);
				      notificationManager.notify(0, mBuilder.build());
			}
		}
	}
}
