package prog.labs.chat.ly;

import prog.labs.chat.ly.db.UserDAO;
import prog.labs.chat.ly.services.InitService;

import com.facebook.Request;
import com.facebook.Response;
import com.facebook.Session;
import com.facebook.SessionState;
import com.facebook.model.GraphUser;
import com.google.android.gcm.GCMRegistrar;
import com.google.android.gms.common.ConnectionResult;
import com.google.android.gms.common.GooglePlayServicesClient;
import com.google.android.gms.common.Scopes;
import com.google.android.gms.common.SignInButton;
import com.google.android.gms.plus.PlusClient;
import android.app.ProgressDialog;
import android.content.IntentSender;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.os.Messenger;
import android.annotation.SuppressLint;
import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.ProgressBar;
import android.widget.Toast;

@SuppressLint("ShowToast")
public class Login extends Activity implements GooglePlayServicesClient.ConnectionCallbacks, GooglePlayServicesClient.OnConnectionFailedListener {

    public static final int REQUEST_CODE_RESOLVE_ERR = 9000;
    private ProgressDialog mConnectionProgressDialog;
    private ConnectionResult mConnectionResult;

    private Button buttonLogin;
    private SignInButton loginGoogle;
    private ProgressBar progreso;
    private Context contexto;
    private UserDAO userdao;
    private  Context contextoactividad =  this;
    private PlusClient mPlusClient;

    private Handler handler = new Handler() {
        public void handleMessage(Message message) {
          if (message.arg1 == RESULT_OK) {
        	  Intent chat = new Intent(Login.this, ChatIndex.class);
        	  startActivity(chat);
          } else {
        	 Toast.makeText(Login.this, "Por ahora nuestros servidores no estan disponibles", Toast.LENGTH_LONG);
          }
        };
      };

    public Login() {
    }

    @Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_login);
		buttonLogin = (Button) findViewById(R.id.loginfacebook);
        loginGoogle = (SignInButton)findViewById(R.id.sign_in_button);
		progreso = (ProgressBar) findViewById(R.id.progresoregistro);
		progreso.setIndeterminate(false);
		progreso.setVisibility(ProgressBar.INVISIBLE);
		contexto = this;
		userdao = new UserDAO(this);
		userdao.abrir();

        Log.d("Chat.ly","Iniciado..");
        mPlusClient = new PlusClient.Builder(this,this,this).setVisibleActivities("http://schemas.google.com/AddActivity", "http://schemas.google.com/BuyActivity") .build();
        buttonLogin.setOnClickListener(new View.OnClickListener() {
			@Override
			public void onClick(View arg0) {
				openSession();
			}
		});
        loginGoogle.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                if (!mPlusClient.isConnected()){
                    mPlusClient.connect();
                }else{
                    mPlusClient.clearDefaultAccount();
                    mPlusClient.disconnect();
                }
            }
        });

    }
	
    protected void openSession() {
		// TODO Auto-generated method stub
        Session.openActiveSession(this, true, new Session.StatusCallback() {
            @Override
            public void call(final Session session, SessionState state, Exception exception) {
                if (session.isOpened()) {
                	progreso.setVisibility(ProgressBar.VISIBLE);
          	      	progreso.setIndeterminate(true);
                    Request.executeMeRequestAsync(session, new Request.GraphUserCallback() {
                                @Override
                                public void onCompleted(GraphUser user, Response response) {
                                    if (user != null) {
                                    	registroUser(user,session.getAccessToken());
                                    }
                                }
                            });
                }else {
                	Toast.makeText(contexto, "Favor de Hacer Login", Toast.LENGTH_LONG).show();
				}
            }
        });
	}

   public void  registroUserPlus(String userid){
        String deviceid = "";
       GCMRegistrar.checkDevice(this);
       GCMRegistrar.checkManifest(this);
       final String regId = GCMRegistrar.getRegistrationId(this);

       if (regId.equals("")) {
           GCMRegistrar.register(this, "601897773013");
           deviceid = GCMRegistrar.getRegistrationId(this);
       }else{
           deviceid = regId;
       }
       userdao.rebootTablaUsuarios();
       userdao.setMainuser(userid);
       userdao.cerrar();
       Intent intent = new Intent(Login.this, InitService.class);
       intent.putExtra("User",userid);
       intent.putExtra("Nombre", userid);
       intent.putExtra("IDGCM", deviceid);
       intent.putExtra("account_type",2);
       intent.putExtra("AccessToken", "");
       Messenger messenger = new Messenger(handler);
       intent.putExtra("MESSENGER", messenger);
       startService(intent);
   }

    public void registroUser(GraphUser usuario,String accesstoken) {
    	String deviceid = "";
    	GCMRegistrar.checkDevice(this);
    	GCMRegistrar.checkManifest(this);
    	final String regId = GCMRegistrar.getRegistrationId(this);
    	
    	if (regId.equals("")) {
    	  GCMRegistrar.register(this, "601897773013");
    	  deviceid = GCMRegistrar.getRegistrationId(this);    	  
    	}else{
    	  deviceid = regId;
    	}
	      userdao.rebootTablaUsuarios();
	      userdao.setMainuser(usuario.getId());
	      userdao.cerrar();
		Intent intent = new Intent(Login.this, InitService.class);
		intent.putExtra("User",usuario.getId());
		intent.putExtra("Nombre", usuario.getName());
		intent.putExtra("IDGCM", deviceid);
        intent.putExtra("account_type",1);
		intent.putExtra("AccessToken", accesstoken);
		Messenger messenger = new Messenger(handler);
		intent.putExtra("MESSENGER", messenger);
		startService(intent);  
    }
    
	@Override
    public void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        Session.getActiveSession().onActivityResult(this, requestCode, resultCode, data);
        if (requestCode == REQUEST_CODE_RESOLVE_ERR   && resultCode == RESULT_OK) {
            mPlusClient.disconnect();
            mPlusClient.connect();
        }
    }

    @Override
    public void onConnected(Bundle bundle) {
        String accountName = mPlusClient.getCurrentPerson().getDisplayName();
        Toast.makeText(this,"Bienvenido "+ accountName + "!!", Toast.LENGTH_LONG) .show();
        registroUserPlus(mPlusClient.getCurrentPerson().getId());
    }

    @Override
    public void onDisconnected() {

    }

    @Override
    public void onConnectionFailed(ConnectionResult connectionResult) {
        if (connectionResult.hasResolution() ) {
            // The user clicked the sign-in button already. Start to resolve
            // connection errors. Wait until onConnected() to dismiss the
            // connection dialog.
            try {
                connectionResult.startResolutionForResult(this, REQUEST_CODE_RESOLVE_ERR);
            } catch (IntentSender.SendIntentException e) {
                mPlusClient.disconnect();
                mPlusClient.connect();
            }
        }
    }
}
