package prog.labs.chat.ly.db;

import java.util.ArrayList;
import java.util.List;

import prog.labs.chat.ly.models.Usuario;
import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteStatement;

public class UserDAO {

	 private SQLiteDatabase database;
	  private DB dbHelper;
	
	  public UserDAO(Context contexto){
		  dbHelper = new DB(contexto);
	  }
	  
	  public void abrir(){
		  database = dbHelper.getWritableDatabase();
	  }
	  
	  public void cerrar(){
		  dbHelper.close();
	  }
	  
	  public void insertarAmigo(Usuario ble){
		  SQLiteStatement statuto = database.compileStatement("INSERT into User values(?,?,?)");
		  statuto.bindString(1, ble.id);
		  statuto.bindString(2, ble.nombre);
		  statuto.bindString(3, ble.imagen);
		  statuto.execute();
	  }
	  
	  public void rebootTablaUsuarios(){
		  database.execSQL("DELETE FROM User");
	  }
	  
	  public List<Usuario> dameUsuarios(){
		  List<Usuario> listatodos = new ArrayList<Usuario>();
		  Cursor c = database.rawQuery("SELECT * from User", null);
		  while (c.moveToNext()) {
			  Usuario ameter = new Usuario();
			  ameter.id = c.getString(0);
			  ameter.nombre = c.getString(1);
			  ameter.imagen = c.getString(2);
			  listatodos.add(ameter);
		}
		  return listatodos;
	  }

	public void setMainuser(String id) {
		// TODO Auto-generated method stub
		database.execSQL("DELETE FROM MainUser");
		SQLiteStatement statuto = database.compileStatement("INSERT into MainUser values(?)");
		statuto.bindString(1, id);
		statuto.execute();
	}

	public String dameUsuarioMain() {
		// TODO Auto-generated method stub
		Cursor cs = database.rawQuery("SELECT * from MainUser", null);
		String userid = "";
		while (cs.moveToNext()) {
			userid = cs.getString(0);
		}
		return userid;
	}

	public String dameUsuarioname(String string) {
		// TODO Auto-generated method stub
		Cursor yepo = database.rawQuery("SELECT * from User where id = '"+string+"' ", null);
		String nombresote = "";
		while (yepo.moveToNext()) {
			nombresote = yepo.getString(1);
		}
		return nombresote;
	}

	public Usuario dameUsuario(String responseString) {
		// TODO Auto-generated method stub
		Cursor yepo = database.rawQuery("SELECT * from User where id = '"+responseString+"'", null);
		Usuario user = new Usuario();
		while (yepo.moveToNext()) {
			user.id = yepo.getString(0);
			user.nombre = yepo.getString(1);
			user.imagen = yepo.getString(2);
		}
		return user;
	}
}
