package prog.labs.chat.ly.models;

import java.util.List;

import com.facebook.Session;

import prog.labs.chat.ly.Login;
import prog.labs.chat.ly.R;
import prog.labs.chat.ly.db.MessageDAO;
import prog.labs.chat.ly.db.UserDAO;
import prog.labs.chat.ly.services.InitService;
import prog.labs.chat.ly.services.SendMessage;
import prog.labs.chat.ly.util.ChatAdapter;

import android.annotation.SuppressLint;
import android.content.Intent;
import android.media.MediaPlayer;
import android.os.Bundle;
import android.os.Messenger;
import android.support.v4.app.Fragment;
import android.view.KeyEvent;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ListView;

@SuppressLint("ValidFragment")
public class ChatFragment extends Fragment {
	
	private String useraconversarid;
	private ChatAdapter chadap;
	private ListView lista;
	private EditText edicion;
	private MediaPlayer sonidomandado;
	private MessageDAO mensajedao;
	private UserDAO usuariodao;

    public ChatFragment(){

    }

	public ChatFragment(Usuario conversarcon) {
		this.useraconversarid = conversarcon.id;
	}

	public ChatFragment(String responseString) {
		// TODO Auto-generated constructor stub
		useraconversarid = responseString;
	}

	@Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
		View v = inflater.inflate(R.layout.activity_chat_index, container, false);
		mensajedao = new MessageDAO(getActivity());
		usuariodao = new UserDAO(getActivity());
		Button botonsint = (Button) v.findViewById(R.id.send);
		sonidomandado = MediaPlayer.create(getActivity(), R.raw.bubble);
		
		usuariodao.abrir();
		Usuario hola = usuariodao.dameUsuario(useraconversarid);
		usuariodao.cerrar();
		getActivity().setTitle(hola.nombre);
		lista = (ListView) v.findViewById(R.id.chatlisti);
		chadap = new ChatAdapter(getActivity(), R.layout.chatitem);
		lista.setAdapter(chadap);
		lista.setTranscriptMode(ListView.TRANSCRIPT_MODE_ALWAYS_SCROLL);
		lista.setStackFromBottom(true);
		edicion = (EditText)v.findViewById(R.id.inputMensaje);
		botonsint.setOnClickListener(new View.OnClickListener() {
			@Override
			public void onClick(View arg0) {
				// TODO Auto-generated method stub
				sonidomandado.start();
				Mensaje mandarmensaje = new Mensaje(false, edicion.getText().toString());
				mandarmensaje.conversacionid = useraconversarid;
				mandarmensaje.emisorid = usuariodao.dameUsuarioMain();
				mandarmensaje.receptorid = useraconversarid;
				mensajedao.abrir();
				mensajedao.InsertarMensaje(mandarmensaje);
				mensajedao.cerrar();
				chadap.add(mandarmensaje);
				edicion.setText("");
				mandarMensajeService(mandarmensaje);
			}
		});
		edicion.setOnKeyListener(new View.OnKeyListener() {
			@Override
			public boolean onKey(View arg0, int arg1, KeyEvent arg2) {
				// TODO Auto-generated method stub
				if ((arg2.getAction() == KeyEvent.ACTION_DOWN) && (arg1 == KeyEvent.KEYCODE_ENTER)) {
					// Perform action on key press
					sonidomandado.start();
					Mensaje mandarmensaje = new Mensaje(false, edicion.getText().toString());
					mandarmensaje.conversacionid = useraconversarid;
					mandarmensaje.emisorid = usuariodao.dameUsuarioMain();
					mandarmensaje.receptorid = useraconversarid;
					mensajedao.abrir();
					mensajedao.InsertarMensaje(mandarmensaje);
					mensajedao.cerrar();
					chadap.add(mandarmensaje);
					edicion.setText("");
					
					mandarMensajeService(mandarmensaje);
					
					return true;
				}
				return false;
			}
		});		
		mensajedao.abrir();
		usuariodao.abrir();
		String usermainid = usuariodao.dameUsuarioMain();
		List<Mensaje> mensajes = mensajedao.dameMensajesConversacion(useraconversarid, usermainid);
		for (int i = 0; i < mensajes.size(); i++) {
			chadap.add(mensajes.get(i));
		}
		mensajedao.cerrar();
		return v;
	}
	
	protected void mandarMensajeService(Mensaje mandarmensaje) {
		// TODO Auto-generated method stub
		Intent intent = new Intent(getActivity(), SendMessage.class);
		intent.putExtra("Userid",mandarmensaje.emisorid);
		intent.putExtra("Touser",mandarmensaje.receptorid);
		intent.putExtra("Mensaje", mandarmensaje.mensaje);
		getActivity().startService(intent); 
	}

	@Override
	public void onSaveInstanceState(Bundle outState) {
		super.onSaveInstanceState(outState);
	}
	
}