package prog.labs.chat.ly.services;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.List;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import prog.labs.chat.ly.db.MessageDAO;
import prog.labs.chat.ly.db.UserDAO;
import prog.labs.chat.ly.models.Mensaje;
import prog.labs.chat.ly.models.Usuario;

import com.facebook.HttpMethod;
import com.facebook.Request;
import com.facebook.Response;
import com.facebook.Session;

import android.app.Activity;
import android.app.IntentService;
import android.content.Intent;
import android.os.Bundle;
import android.os.Message;
import android.os.Messenger;
import android.util.Log;

public class InitService extends IntentService{

	private UserDAO userdao;
	private MessageDAO mensajedao;
	
	public InitService() {
		super("RegisterUserService");
		// TODO Auto-generated constructor stub
	}

	@Override
	protected void onHandleIntent(Intent intent) {
		// TODO Auto-generated method stub
		userdao = new UserDAO(this);
		mensajedao = new MessageDAO(this);
		String idUser = intent.getStringExtra("User");
		String accesstoken = intent.getStringExtra("AccessToken");
		String IDgcm = intent.getStringExtra("IDGCM");
        int accounttype = intent.getIntExtra("account_type",1);

		//Parte del service para registro de usuarios;
		HttpClient httpclient = new DefaultHttpClient();
		HttpPost httppost =  new HttpPost("http://209.141.55.205/requests.php");
		JSONObject datos = new JSONObject();
		try {
			datos.put("type", "crear_usuario");
				JSONObject request = new JSONObject();
				request.put("userid", idUser);
				request.put("accesstoken", accesstoken);
			datos.put("request", request);
			List<NameValuePair> nameValuePairs = new ArrayList<NameValuePair>(1);
			System.out.println(datos.toString());
			nameValuePairs.add(new BasicNameValuePair("query", datos.toString()));
			httppost.setEntity(new UrlEncodedFormEntity(nameValuePairs));
			HttpResponse response = httpclient.execute(httppost);
		} catch (JSONException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (UnsupportedEncodingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ClientProtocolException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		//Parte del service para agregar dispositivos
		HttpClient hola = new DefaultHttpClient();
		HttpPost posteardispositivo = new HttpPost("http://209.141.55.205/requests.php");
		JSONObject kerollo = new JSONObject();
		try {
			kerollo.put("type", "agregar_dispositivo");
				JSONObject dispositivo = new JSONObject();
				dispositivo.put("userid", idUser);
				dispositivo.put("accesstoken", accesstoken);
				dispositivo.put("pushid", IDgcm);
				dispositivo.put("devicetype", "Android");
			kerollo.put("request", dispositivo);
			List<NameValuePair> nameValuePairs = new ArrayList<NameValuePair>(1);
			nameValuePairs.add(new BasicNameValuePair("query", kerollo.toString()));
			posteardispositivo.setEntity(new UrlEncodedFormEntity(nameValuePairs));
			HttpResponse respuesta = hola.execute(posteardispositivo);
		} catch (JSONException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (UnsupportedEncodingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ClientProtocolException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		//Service para obtener usuarios conectados
		//Llamada a fql en caso de que sea un usuario de Facebook
        if (accounttype == 1){
            userdao.abrir();
            String fqlQuery = "SELECT uid,name,pic_square FROM user WHERE uid IN (SELECT uid2 FROM friend WHERE uid1 = "+idUser+") AND is_app_user = 1";
            Bundle params = new Bundle();
            params.putString("q", fqlQuery);
            Session session = Session.getActiveSession();
            Request request = new Request(session,
                    "/fql",
                    params,
                    HttpMethod.GET,
                    new Request.Callback(){
                        @Override
                        public void onCompleted(Response response) {
                            // TODO Auto-generated method stub
                            JSONObject datos = response.getGraphObject().getInnerJSONObject();
                            try {
                                JSONArray arregloamiguis = datos.getJSONArray("data");
                                for (int i = 0; i < arregloamiguis.length(); i++) {
                                    JSONObject amigo = arregloamiguis.getJSONObject(i);
                                    Usuario agregaamigo = new Usuario();
                                    agregaamigo.id = amigo.getString("uid");
                                    agregaamigo.nombre = amigo.getString("name");
                                    agregaamigo.imagen = amigo.getString("pic_square");
                                    userdao.insertarAmigo(agregaamigo);
                                }
                                userdao.cerrar();
                            } catch (JSONException e) {
                                // TODO Auto-generated catch block
                                e.printStackTrace();
                            }
                        }
                    });
            Request.executeAndWait(request);
        }else if (accounttype == 2){
               //Obtener amigos de google plus asyncronamente
        }
			
			//Parte del service para obtener conversaciones
			mensajedao.abrir();
			mensajedao.rebootMessages();
			mensajedao.cerrar();
			
			userdao.abrir();
			List<Usuario> usuarios = userdao.dameUsuarios();
			userdao.cerrar();
			for (int i = 0; i < usuarios.size(); i++) {
				HttpClient cliente = new DefaultHttpClient();
				HttpPost damemensajes = new HttpPost("http://209.141.55.205/requests.php");
				JSONObject query = new JSONObject();
				try {
					query.put("type","recuperar_mensajes");
						JSONObject requesto = new JSONObject();
						requesto.put("userid", idUser);
						requesto.put("accesstoken", accesstoken);
						requesto.put("otheruserid", usuarios.get(i).id);
						requesto.put("lastmsg", "0");
					query.put("request", requesto);
					List<NameValuePair> nameValuePairs = new ArrayList<NameValuePair>(1);
					nameValuePairs.add(new BasicNameValuePair("query", query.toString()));
					damemensajes.setEntity(new UrlEncodedFormEntity(nameValuePairs));
					
					HttpResponse respuestota = cliente.execute(damemensajes);
					
					HttpEntity entidad = respuestota.getEntity();
					InputStream contenido = entidad.getContent();
					
					BufferedReader reader = new BufferedReader(new InputStreamReader(contenido,"iso-8859-1"),8);
					StringBuilder sb = new StringBuilder();
					String line = null;
					while ((line = reader.readLine()) != null) {
						sb.append(line + "\n");
					}
					contenido.close();
					String resultado = sb.toString();
					System.out.println(resultado);
					JSONObject objetofinal = new JSONObject(resultado);
					JSONArray mensajes = objetofinal.getJSONArray("messages");
					for (int j = 0; j < mensajes.length(); j++) {
						boolean esdelusuario = true;
						if (mensajes.getJSONObject(j).getString("fromuserid").equals(idUser)) {
							esdelusuario = false;
						}
						Mensaje nuevomensaje = new Mensaje(esdelusuario, mensajes.getJSONObject(j).getString("message"));
						nuevomensaje.emisorid = mensajes.getJSONObject(j).getString("fromuserid");
						nuevomensaje.receptorid = mensajes.getJSONObject(j).getString("touserid");
						nuevomensaje.conversacionid = usuarios.get(i).id;
						mensajedao.abrir();
						mensajedao.InsertarMensaje(nuevomensaje);
						mensajedao.cerrar();
					}
					System.out.println(objetofinal.toString());
				} catch (JSONException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (UnsupportedEncodingException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (ClientProtocolException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
			
			//Termina Service para obtener conversaciones
			//Y mandamos un mensaje pa decir que ya acabamos chidi :D
		int result = Activity.RESULT_OK;
		 Bundle extras = intent.getExtras();
		    if (extras != null) {
		      Messenger messenger = (Messenger) extras.get("MESSENGER");
		      Message msg = Message.obtain();
		      msg.arg1 = result;
		      try {
		        messenger.send(msg);
		      } catch (android.os.RemoteException e1) {
		        Log.w(getClass().getName(), "Exception sending message", e1);
		      }
		    }
	}
}
