package prog.labs.chat.ly.util;

import java.util.ArrayList;
import java.util.List;

import prog.labs.chat.ly.R;
import prog.labs.chat.ly.models.Mensaje;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.LinearLayout;
import android.widget.TextView;

public class ChatAdapter extends ArrayAdapter<Mensaje>{

	private TextView nombre;
	private List<Mensaje> countries = new ArrayList<Mensaje>();
	private LinearLayout wrapper;
	
	@Override
	public void add(Mensaje object) {
		countries.add(object);
		super.add(object);
	}

	
	public int getCount() {
		return this.countries.size();
	}

	public Mensaje getItem(int index) {
		return this.countries.get(index);
	}
	
	public void reloadmessages(){
		this.countries.clear();
	}
	
	public ChatAdapter(Context context, int textViewResourceId) {
		super(context, textViewResourceId);
		// TODO Auto-generated constructor stub
	}

	@Override
	public View getView(int position, View convertView, ViewGroup parent) {
		// TODO Auto-generated method stub
		View row = convertView;
		if (row == null) {
			LayoutInflater inflater = (LayoutInflater) this.getContext().getSystemService(Context.LAYOUT_INFLATER_SERVICE);
			row = inflater.inflate(R.layout.chatitem, parent, false);
		}
		wrapper = (LinearLayout) row.findViewById(R.id.wrapper);
		Mensaje mens = getItem(position);
		nombre = (TextView)row.findViewById(R.id.comment);
		nombre.setText(mens.mensaje);
		nombre.setBackgroundResource(mens.ida ?  R.drawable.bubble_green : R.drawable.bubble_blue);
		wrapper.setGravity(mens.ida ? Gravity.LEFT : Gravity.RIGHT);
		return row;
	}
	
	public Bitmap decodeToBitmap(byte[] decodedByte) {
		return BitmapFactory.decodeByteArray(decodedByte, 0, decodedByte.length);
	}
}
